PIRL.Conductor

## Class Manager

- java.lang.Object
- - java.awt.Component
  - - java.awt.Container
    - - java.awt.Window
      - - java.awt.Frame
        - - javax.swing.JFrame
          - - PIRL.Conductor.Manager

All Implemented Interfaces:
  ImageObserver, MenuContainer, Serializable, EventListener, Accessible, RootPaneContainer, WindowConstants, Processing_Listener

    public class Manager
    extends JFrame
    implements Processing_Listener

A Manager is a GUI for managing a Conductor.

##### Configuration parameters

The following configuration parameters may be used by a Conductor Manager:

Splash_Screen
  While the Manager is initializing the GUI it will, by default, display a spash screen. To disable this feature set the Splash_Screen value to "disabled", "false", "no" or 0. The value may also be set to the minimum number of seconds that the splash screen should remain visible; not less than three seconds (unless 0) is allowed.
Manager_Width
  The width of the Manager window (pixels). Default: 750.
Manager_Height
  The height of the Manager window (pixels). Default: 463.
Manager_Location_X
  The initial horizontal screen position of the Manager window. Default: 300.
Manager_Location_Y
  The initial vertical screen position of the Manager window. Default: 100.
Monitor_Width
  The width of the log stream monitor pane (pixels). Default: 700.
Monitor_Height
  The height of the loc stream monitor pane (pixels). Default: 400.
Tooltips
  If set to "enabled", "true", "yes" or 1 (case insensitive) GUI component tooltips will be enabled on startup. Default: enabled.

See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class javax.swing.JFrame

`JFrame.AccessibleJFrame`

### Nested classes/interfaces inherited from class java.awt.Frame

`Frame.AccessibleAWTFrame`

### Nested classes/interfaces inherited from class java.awt.Window

`Window.AccessibleAWTWindow, Window.Type`

### Nested classes/interfaces inherited from class java.awt.Container

`Container.AccessibleAWTContainer`

### Nested classes/interfaces inherited from class java.awt.Component

`Component.AccessibleAWTComponent, Component.BaselineResizeBehavior, Component.BltBufferStrategy, Component.FlipBufferStrategy`

### Field Summary

Fields
`static boolean` `DEFAULT_LOG_WHILE_CLOSED`
`static int` `DEFAULT_MAX_SOURCES_ROWS`
`static boolean` `DEFAULT_STATUS_ANNUNCIATOR`
`static int` `EXITING`
`static String` `FAILURE_ICON_NAME`
`static String` `ICONS_DIRECTORY` Class-relative name of the directory containing icon/image files.
`static String` `ID` Class identification name with source code version and date.
`static String` `MANAGER_HEIGHT_PARAMETER_NAME` Configuration parameters.
`static String` `MANAGER_LOCATION_X_PARAMETER_NAME` Configuration parameters.
`static String` `MANAGER_LOCATION_Y_PARAMETER_NAME` Configuration parameters.
`static String` `MANAGER_WIDTH_PARAMETER_NAME` Configuration parameters.
`static String` `MONITOR_HEIGHT_PARAMETER_NAME` Configuration parameters.
`static String` `MONITOR_WIDTH_PARAMETER_NAME` Configuration parameters.
`static int` `SPLASH_SCREEN_MINIMUM_TIME` Minimum splash screen display time (seconds) if enabled.
`static String` `SPLASH_SCREEN_PARAMETER_NAME` Configuration parameters.
`static String` `SUCCESS_ICON_NAME`
`static String` `TOOLTIPS_PARAMETER_NAME` Configuration parameters.
`static int` `WARNING`
`static String` `WARNING_ICON_NAME`

### Fields inherited from class javax.swing.JFrame

`accessibleContext, EXIT_ON_CLOSE, rootPane, rootPaneCheckingEnabled`

### Fields inherited from class java.awt.Frame

`CROSSHAIR_CURSOR, DEFAULT_CURSOR, E_RESIZE_CURSOR, HAND_CURSOR, ICONIFIED, MAXIMIZED_BOTH, MAXIMIZED_HORIZ, MAXIMIZED_VERT, MOVE_CURSOR, N_RESIZE_CURSOR, NE_RESIZE_CURSOR, NORMAL, NW_RESIZE_CURSOR, S_RESIZE_CURSOR, SE_RESIZE_CURSOR, SW_RESIZE_CURSOR, TEXT_CURSOR, W_RESIZE_CURSOR, WAIT_CURSOR`

### Fields inherited from class java.awt.Component

`BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

### Fields inherited from interface javax.swing.WindowConstants

`DISPOSE_ON_CLOSE, DO_NOTHING_ON_CLOSE, HIDE_ON_CLOSE`

### Fields inherited from interface java.awt.image.ImageObserver

`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

### Constructor Summary

Constructors
Constructor and Description
`Manager(Management management)`
`Manager(Management management, Configuration configuration)` Constructs a Conductor Manager.

### Method Summary

Methods
`void` `Close()` Close and dispose of this Manager.
`String` `Config_Pathname(String name)` Get the configuration pathname for a parameter name.
`String` `Config_Value(String name)` Get the String value of a configuration parameter.
`int` `Default_Max_Sources_Rows()`
`Manager` `Default_Max_Sources_Rows(int rows)`
`void` `Disable()`
`static boolean` `Local_Management(Management management)` Test for a Management interface local to a Conductor.
`Management` `Management()`
`int` `Max_Sources_Rows()`
`Manager` `Max_Sources_Rows(int rows)`
`void` `Processing_Event_Occurred(Processing_Event event)` A Conductor Processing_Event occured.
`void` `Quit_Conductor()` Signal the Conductor to quit.
`void` `Stop_Conductor()`

### Methods inherited from class javax.swing.JFrame

`addImpl, createRootPane, frameInit, getAccessibleContext, getContentPane, getDefaultCloseOperation, getGlassPane, getGraphics, getJMenuBar, getLayeredPane, getRootPane, getTransferHandler, isDefaultLookAndFeelDecorated, isRootPaneCheckingEnabled, paramString, processWindowEvent, remove, repaint, setContentPane, setDefaultCloseOperation, setDefaultLookAndFeelDecorated, setGlassPane, setIconImage, setJMenuBar, setLayeredPane, setLayout, setRootPane, setRootPaneCheckingEnabled, setTransferHandler, update`

### Methods inherited from class java.awt.Frame

`addNotify, getCursorType, getExtendedState, getFrames, getIconImage, getMaximizedBounds, getMenuBar, getState, getTitle, isResizable, isUndecorated, remove, removeNotify, setBackground, setCursor, setExtendedState, setMaximizedBounds, setMenuBar, setOpacity, setResizable, setShape, setState, setTitle, setUndecorated`

### Methods inherited from class java.awt.Window

`addPropertyChangeListener, addPropertyChangeListener, addWindowFocusListener, addWindowListener, addWindowStateListener, applyResourceBundle, applyResourceBundle, createBufferStrategy, createBufferStrategy, dispose, getBackground, getBufferStrategy, getFocusableWindowState, getFocusCycleRootAncestor, getFocusOwner, getFocusTraversalKeys, getIconImages, getInputContext, getListeners, getLocale, getModalExclusionType, getMostRecentFocusOwner, getOpacity, getOwnedWindows, getOwner, getOwnerlessWindows, getShape, getToolkit, getType, getWarningString, getWindowFocusListeners, getWindowListeners, getWindows, getWindowStateListeners, hide, isActive, isAlwaysOnTop, isAlwaysOnTopSupported, isAutoRequestFocus, isFocusableWindow, isFocusCycleRoot, isFocused, isLocationByPlatform, isOpaque, isShowing, isValidateRoot, pack, paint, postEvent, processEvent, processWindowFocusEvent, processWindowStateEvent, removeWindowFocusListener, removeWindowListener, removeWindowStateListener, reshape, setAlwaysOnTop, setAutoRequestFocus, setBounds, setBounds, setCursor, setFocusableWindowState, setFocusCycleRoot, setIconImages, setLocation, setLocation, setLocationByPlatform, setLocationRelativeTo, setMinimumSize, setModalExclusionType, setSize, setSize, setType, setVisible, show, toBack, toFront`

### Methods inherited from class java.awt.Container

`add, add, add, add, add, addContainerListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getAlignmentX, getAlignmentY, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalPolicy, getInsets, getLayout, getMaximumSize, getMinimumSize, getMousePosition, getPreferredSize, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, print, printComponents, processContainerEvent, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusTraversalKeys, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setFont, transferFocusDownCycle, validate, validateTree`

### Methods inherited from class java.awt.Component

`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, contains, createImage, createImage, createVolatileImage, createVolatileImage, disable, disableEvents, dispatchEvent, enable, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBaseline, getBaselineResizeBehavior, getBounds, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getFontMetrics, getForeground, getGraphicsConfiguration, getHeight, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocation, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getSize, getTreeLock, getWidth, getX, getY, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isDoubleBuffered, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, prepareImage, prepareImage, printAll, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processKeyEvent, processMouseEvent, processMouseMotionEvent, processMouseWheelEvent, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resize, resize, revalidate, setComponentOrientation, setDropTarget, setEnabled, setFocusable, setFocusTraversalKeysEnabled, setForeground, setIgnoreRepaint, setLocale, setMaximumSize, setName, setPreferredSize, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface java.awt.MenuContainer

`getFont, postEvent`

### Field Detail

#### ID

    public static final String ID

Class identification name with source code version and date.

See Also:
  Constant Field Values

#### SPLASH_SCREEN_PARAMETER_NAME

    public static final String SPLASH_SCREEN_PARAMETER_NAME

Configuration parameters.

See Also:
  Constant Field Values

#### MANAGER_WIDTH_PARAMETER_NAME

    public static final String MANAGER_WIDTH_PARAMETER_NAME

Configuration parameters.

See Also:
  Constant Field Values

#### MANAGER_HEIGHT_PARAMETER_NAME

    public static final String MANAGER_HEIGHT_PARAMETER_NAME

Configuration parameters.

See Also:
  Constant Field Values

#### MANAGER_LOCATION_X_PARAMETER_NAME

    public static final String MANAGER_LOCATION_X_PARAMETER_NAME

Configuration parameters.

See Also:
  Constant Field Values

#### MANAGER_LOCATION_Y_PARAMETER_NAME

    public static final String MANAGER_LOCATION_Y_PARAMETER_NAME

Configuration parameters.

See Also:
  Constant Field Values

#### TOOLTIPS_PARAMETER_NAME

    public static final String TOOLTIPS_PARAMETER_NAME

Configuration parameters.

See Also:
  Constant Field Values

#### MONITOR_WIDTH_PARAMETER_NAME

    public static final String MONITOR_WIDTH_PARAMETER_NAME

Configuration parameters.

See Also:
  Constant Field Values

#### MONITOR_HEIGHT_PARAMETER_NAME

    public static final String MONITOR_HEIGHT_PARAMETER_NAME

Configuration parameters.

See Also:
  Constant Field Values

#### ICONS_DIRECTORY

    public static final String ICONS_DIRECTORY

Class-relative name of the directory containing icon/image files.

See Also:
  Constant Field Values

#### SPLASH_SCREEN_MINIMUM_TIME

    public static final int SPLASH_SCREEN_MINIMUM_TIME

Minimum splash screen display time (seconds) if enabled.

See Also:
  Constant Field Values

#### DEFAULT_MAX_SOURCES_ROWS

    public static final int DEFAULT_MAX_SOURCES_ROWS

See Also:
  Constant Field Values

#### WARNING

    public static final int WARNING

See Also:
  Constant Field Values

#### EXITING

    public static final int EXITING

See Also:
  Constant Field Values

#### SUCCESS_ICON_NAME

    public static final String SUCCESS_ICON_NAME

See Also:
  Constant Field Values

#### FAILURE_ICON_NAME

    public static final String FAILURE_ICON_NAME

See Also:
  Constant Field Values

#### WARNING_ICON_NAME

    public static final String WARNING_ICON_NAME

See Also:
  Constant Field Values

#### DEFAULT_STATUS_ANNUNCIATOR

    public static final boolean DEFAULT_STATUS_ANNUNCIATOR

See Also:
  Constant Field Values

#### DEFAULT_LOG_WHILE_CLOSED

    public static final boolean DEFAULT_LOG_WHILE_CLOSED

See Also:
  Constant Field Values

### Constructor Detail

#### Manager

    public Manager(Management management,
           Configuration configuration)
            throws Remote_Management_Exception

Constructs a Conductor Manager.

The Configuration object is expected to contain all the necessary information Conductor needs to connect to the database as well as any other Conductor parameters it might use.

Parameters:
  `management` - A Condcutor_Mangement object that is a Conductor or a proxy - such as a Stage_Manager system - for managing a Conductor.
Throws:
  `IllegalArgumentException` - If the management is null.
  `Remote_Management_Exception` - If a Conductor Management protocol error occurs. This can only happen if the management is not `local` to a Conductor.

#### Manager

    public Manager(Management management)
            throws Remote_Management_Exception

Throws:
  `Remote_Management_Exception`

### Method Detail

#### Management

    public Management Management()

#### Default_Max_Sources_Rows

    public int Default_Max_Sources_Rows()

#### Default_Max_Sources_Rows

    public Manager Default_Max_Sources_Rows(int rows)

#### Max_Sources_Rows

    public int Max_Sources_Rows()

#### Max_Sources_Rows

    public Manager Max_Sources_Rows(int rows)

#### Config_Pathname

    public String Config_Pathname(String name)

Get the configuration pathname for a parameter name.

If the name is not an `absolute pathname` the `Conductor.CONDUCTOR_GROUP` name is prepended to the name to form an absolute pathname.

Parameters:
  `name` - A parameter name String.
Returns:
  The possibily modified abosulte pathname String.

#### Config_Value

    public String Config_Value(String name)

Get the String value of a configuration parameter.

The first value of a Parameter with an Array Value will be returned.

Parameters:
  `name` - The name of the parameter from which to obtain the value. If the name may be `qualified` before use.
Returns:
  A String value. This will be null if the parameter could not be found in the Conductor configuration.

#### Stop_Conductor

    public void Stop_Conductor()

#### Quit_Conductor

    public void Quit_Conductor()

Signal the Conductor to quit.

If the Conductor is in the running `processing state` a confirmation dialog is presented before source processing is aborted.

Caution: If the Conductor is polling for sources it is possible that it will acquire a source and begin processing it before the quit signal is received causing the processing of the source to be aborted.

#### Close

    public void Close()

Close and dispose of this Manager.

If the Conductor Management interface is a Conductor it will be told to `quit`. Otherwise the Conductor `Log stream` and `processing event` listeners are unregistered and the Conductor is left in its current state.

#### Disable

    public void Disable()

#### Processing_Event_Occurred

    public void Processing_Event_Occurred(Processing_Event event)

Description copied from interface: `Processing_Listener`
A Conductor Processing_Event occured.

Whenever a significant processing event occurs by a Conductor it sends a Processing_Event to all `registered` listeners.

Specified by:
  `Processing_Event_Occurred` in interface `Processing_Listener`
Parameters:
  `event` - A Conductor Processing_Event.
See Also:
  `Processing_Event`

#### Local_Management

    public static boolean Local_Management(Management management)

Test for a Management interface local to a Conductor.

A local Management interface is implemented by the Conductor class; if the management is an instance of the Conductor class it is local.

Parameters:
  `management` - A Management interface instance to test.
Returns:
  true if the management is a local Conductor instance; false otherwise.